import java.util.NoSuchElementException;

public class ArrayGSack<T> implements GSackADT<T> {

	// Internal storage and accounting members
	protected T[] items;
	protected int numItems;
	private static final int INIT_SIZE = 100;

	public ArrayGSack() {
		items = (T[]) new Object[INIT_SIZE];
		numItems = 0;
	}

	public void add(T item) {
		if (numItems == items.length) expandStorage();
		items[numItems++] = item;
	}

	public T remove() throws NoSuchElementException {
		if (numItems < 1) throw new NoSuchElementException();
		return items[--numItems];
	}

	public boolean isEmpty() {
		return numItems == 0;
	}

	// Internal method to handle capacity issues
	private void expandStorage() {
		T[] oldItems = items;
		items = (T[]) new Object[2 * items.length];
		for (int i = 0; i < oldItems.length; i++) 
			items[i] = oldItems[i];
	}
}
